/*
 * smartt-network.c
 *
 * Perf manger
*/

#include "smartt-network.h"
#include "smartt-utils.h"

struct s_network_config local_host;
struct s_network_config remote_server;
struct s_network_config trace_server;

int SMARTTclient_OpenLocalServer()
{
    bool status;

    rx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (rx_sock_desc == -1)
    {
        fprintf(stderr,"[E] Error opening Rx Server\t\t: Error\n");
        return(0);
    }

    Rx_server_addr.sin_family = AF_INET;
    Rx_server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    Rx_server_addr.sin_port  = (local_host.port_no);

    status = bind(rx_sock_desc,(struct sockaddr *)&Rx_server_addr, sizeof(Rx_server_addr));
    if (status == -1)
    {
        fprintf(stderr, "[E] Failed to bind the client\t\t: Error\n");
        return(0);
    }

    addr_len = sizeof(struct sockaddr);

    return(1);
}

int SMARTTclient_OpenRemoteServer() 
{
    struct  hostent *hp;

    tx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (tx_sock_desc == -1)
    {
        fprintf(stderr,"[E] Error opening Tx Server\t\t: Error\n");
        return(0);
    }

    Tx_server_addr.sin_family = AF_INET;
    Tx_server_addr.sin_port  = (remote_server.port_no);

    hp = gethostbyname(remote_server.host_ip);
    bcopy (hp->h_addr,&(Tx_server_addr.sin_addr),hp->h_length);

    return(1);
}


int SMARTTclient_OpenTracePort() 
{
    struct hostent *hp;
    
    
    if ((trace_sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
    {
        perror("socket");
        exit(1);
    }
    
    TRACE_server_addr.sin_family = AF_INET;
    TRACE_server_addr.sin_port = (trace_server.port_no);

    hp = gethostbyname(trace_server.host_ip);
    bcopy (hp->h_addr,&(TRACE_server_addr.sin_addr),hp->h_length);

    return(1);
}

int SMARTTclient_GetNetworkConfig()
{
    char param_type[64];

    FILE *f1 = fopen("/etc/smartt/smartt-networks.conf","r");
    if (f1== NULL)
    {
        fprintf(stderr, "[E] Cannot open /etc/smartt/smartt-networks.conf \t\t: Error\n");
        return (0);
    }

    fscanf(f1,"%s %s\n",param_type, local_host.host_ip);
    fscanf(f1,"%s %d\n",param_type, &local_host.port_no);
    fscanf(f1,"%s %s\n",param_type, remote_server.host_ip);
    fscanf(f1,"%s %d\n",param_type, &remote_server.port_no);
    fscanf(f1,"%s %s\n",param_type, trace_server.host_ip);
    fscanf(f1,"%s %d\n",param_type, &trace_server.port_no);

    return(1);
}

