/*
* build-id.c
*
* build-id support
*
* Copyright (C) 20011, 2012 Linaro Inc.
* Copyright (C) 2011, 2012 Sudip Jain <sudip.jain@linaro.org>
*/

#include "util.h"
#include "connect.h"

int sock_desc;
struct sockaddr_in server;
struct s_system_stat sys_stats;

void SMARTTperf_Connect(void) 
{
    struct  hostent *hp;

    sock_desc = socket(AF_INET,SOCK_DGRAM,0);

    server.sin_family = AF_INET;
    server.sin_port  = (4000);

    hp = gethostbyname("127.0.0.1");
    bcopy (hp->h_addr,&(server.sin_addr),hp->h_length);
}

void SMARTTperf_StatPid(pid_t *pid)
{
    sys_stats.pid = *pid;
}

void SMARTTperf_StatMetrics(double *avg, const char *event)
{

        if (strcmp(event, "cycles") == 0 )
            sys_stats.cpu_cycles = *avg;
        else if (strcmp(event, "instructions") == 0 )
            sys_stats.instructions = *avg;
        else if (strcmp(event, "bus-cycles") == 0 )
            sys_stats.bus_cycles = *avg;
        else if (strcmp(event, "cache-misses") == 0 )
            sys_stats.cache_misses = *avg;
        else if (strcmp(event, "branches") == 0 )
            sys_stats.branches = *avg;
}

void SMARTTperf_SendData(void)
{
        sys_stats.time_stamp    =   time(NULL);
        sendto(sock_desc, (void *)&sys_stats, sizeof(sys_stats),0,(struct sockaddr *) &server, sizeof(server));
}
