from pylab import *
import time
import socket
import string

server_socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
server_socket.bind(("", 6000))

fig = figure(1,figsize=(16,12));ion();
subplots_adjust(hspace = 0.3)

sample_limit = 50;
sample_no = 0;
xmin = sample_no;
xmax = sample_no + sample_limit;


cc_axis = subplot(421, autoscale_on=False, xlim=(0,sample_limit), ylim=(-1e8,5e8))
cc_axis.grid(color='k', linestyle=':', linewidth=1)
cc_axis.set_title('cpu-cycles')
cc_axis.axhline(y=1e8, xmin=0, xmax=sample_limit,linewidth=1.5, color='r',linestyle="--")

in_axis = subplot(423, autoscale_on=False, xlim=(0,sample_limit), ylim=(-1e7,1e8))
in_axis.grid(color='k', linestyle=':', linewidth=1)
in_axis.set_title('instructions')
in_axis.axhline(y=5e7, xmin=0, xmax=sample_limit,linewidth=1.5, color='r',linestyle="--")

##bc_axis = subplot(423,  autoscale_on=False, xlim=(0,sample_limit), ylim=(-1e7,1e8))
##bc_axis.grid(color='k', linestyle=':', linewidth=1)
##bc_axis.set_title('bus-cycles')

cm_axis = subplot(425,  autoscale_on=False, xlim=(0,sample_limit), ylim=(-1e8, 5e8))
cm_axis.grid(color='k', linestyle=':', linewidth=1)
cm_axis.set_title('cache-misses')
cm_axis.axhline(y=1e8, xmin=0, xmax=sample_limit,linewidth=1.5, color='r',linestyle="--")

##br_axis = subplot(427,  autoscale_on=False, xlim=(0,sample_limit), ylim=(-1e6,2e7))
##br_axis.grid(color='k', linestyle=':', linewidth=1)
##br_axis.set_title('branches')
##br_axis.axhline(y=5e6, xmin=0, xmax=sample_limit,linewidth=1.5, color='r',linestyle="--")

mu_axis = subplot(427,  autoscale_on=False, xlim=(0,sample_limit), ylim=(900,1e3))
mu_axis.grid(color='k', linestyle=':', linewidth=1)
mu_axis.set_title('mem-usage (k)')
mu_axis.axhline(y=950, xmin=0, xmax=sample_limit,linewidth=1.5, color='r',linestyle="--")

cf_axis = subplot(422,  autoscale_on=False, xlim=(0,sample_limit), ylim=(15,30))
cf_axis.grid(color='k', linestyle=':', linewidth=1)
cf_axis.set_title('current-fps')
cf_axis.axhline(y=20, xmin=0, xmax=sample_limit,linewidth=1.5, color='g',linestyle="--")

af_axis = subplot(424,  autoscale_on=False, xlim=(0,sample_limit), ylim=(20,40))
af_axis.grid(color='k', linestyle=':', linewidth=1)
af_axis.set_title('average-fps')
af_axis.axhline(y=25, xmin=0, xmax=sample_limit,linewidth=1.5, color='g',linestyle="--")

re_axis = subplot(426,  autoscale_on=False, xlim=(0,sample_limit), ylim=(0,5e3))
re_axis.grid(color='k', linestyle=':', linewidth=1)
re_axis.set_title('rendered frames')

dr_axis = subplot(428,  autoscale_on=False, xlim=(0,sample_limit), ylim=(0,1e2))
dr_axis.grid(color='k', linestyle=':', linewidth=1)
dr_axis.set_title('dropped frames')

cc_x = [0,0]; cc_y = [0,0];
in_x = [0,0]; in_y = [0,0];
bc_x = [0,0]; bc_y = [0,0];
cm_x = [0,0]; cm_y = [0,0];
br_x = [0,0]; br_y = [0,0];
mu_x = [0,0]; mu_y = [0,0];
cf_x = [0,0]; cf_y = [0,0];
af_x = [0,0]; af_y = [0,0];
re_x = [0,0]; re_y = [0,0];
dr_x = [0,0]; dr_y = [0,0];

print"UDPServer Waiting for client on port 6000"    
# close the connection

while (1):
    stat_table, address = server_socket.recvfrom(256)         
    print stat_table
    system_data = string.split(stat_table)
    total_items = len(system_data);
    item_num = 0;
    pid = system_data[item_num];
    item_num +=1;
    time_stamp = system_data[item_num];
    item_num +=1;
 
    while total_items > item_num :
        if system_data[item_num] == "cc":
            item_num +=1;
            cpu_cycles = system_data[item_num]
            item_num +=1;
            if system_data[item_num] == "(+)":
                cpu_cycles_wml = 1;
            elif system_data[item_num] == "(.)":
                cpu_cycles_wml = 0;
            item_num +=1;
            
            del cc_x[0]; del cc_y[0];
            cc_x.append(sample_no); cc_y.append(cpu_cycles);
            if (cpu_cycles_wml == 1):
                cc_axis.plot(sample_no,cpu_cycles,'ro', markersize=5)
            else:
                cc_axis.plot(sample_no,cpu_cycles,'bo', markersize=5)
            cc_axis.plot(cc_x,cc_y,'c-',linewidth=0.5)
            
        if system_data[item_num] == "in":
            item_num +=1;
            instructions = system_data[item_num]
            item_num +=1;
            if system_data[item_num] == "(+)":
                instructions_wml = 1;
            elif system_data[item_num] == "(.)":
                instructions_wml = 0;
            item_num +=1;
            del in_x[0]; del in_y[0];
            in_x.append(sample_no); in_y.append(instructions);
            if (instructions_wml == 1):
                in_axis.plot(sample_no , instructions,'ro',markersize=5)
            else:
                in_axis.plot(sample_no , instructions,'bo',markersize=5)
            in_axis.plot(in_x,in_y,'c-',linewidth=0.5)


##***************- BUS-CYCLES******************************
            
##        if system_data[item_num] == "bc":
##            item_num +=1;
##            bus_cycles = system_data[item_num]
##            item_num +=1;
##            if system_data[item_num] == "(+)":
##                bus_cycles_wml = 1;
##            elif system_data[item_num] == "(.)":
##                bus_cycles_wml = 0;
##            item_num +=1;
##            print "BUS-CYCLES           :", bus_cycles
##            print "BUS-CYCLES-WML       :", bus_cycles_wml
##            del bc_x[0]; del bc_y[0];
##            bc_x.append(sample_no); bc_y.append(bus_cycles);
##            if (bus_cycles_wml == 1):
##                bc_axis.plot(sample_no , bus_cycles,'ro-',markersize=5)
##            else:
##                bc_axis.plot(sample_no , bus_cycles,'bo-',markersize=5)
##            bc_axis.plot(bc_x,bc_y,'c-',linewidth=0.5)

            
##*************** CACHE-MISSES ******************************

        if system_data[item_num] == "cm":
            item_num +=1;
            cache_misses = system_data[item_num]
            item_num +=1;
            if system_data[item_num] == "(+)":
                cache_misses_wml = 1;
            elif system_data[item_num] == "(.)":
                cache_misses_wml = 0;
            item_num +=1;
            del cm_x[0]; del cm_y[0];
            cm_x.append(sample_no); cm_y.append(cache_misses);
            if (cache_misses_wml == 1):
                cm_axis.plot(sample_no , cache_misses,'ro',markersize=5)
            else:
                cm_axis.plot(sample_no , cache_misses,'bo',markersize=5)
            cm_axis.plot(cm_x,cm_y,'c-',linewidth=0.5)


####*************** BRANCHES ******************************
##
##        if system_data[item_num] == "br":
##            item_num +=1;
##            branches = system_data[item_num]
##            item_num +=1;
##            if system_data[item_num] == "(+)":
##                branches_wml = 1;
##            elif system_data[item_num] == "(.)":
##                branches_wml = 0;
##            item_num +=1;
##            del br_x[0]; del br_y[0];
##            br_x.append(sample_no); br_y.append(branches);
##            if (branches_wml == 1):
##                br_axis.plot(sample_no , branches,'ro',markersize=5)
##            else:
##                br_axis.plot(sample_no , branches,'bo',markersize=5)
##            br_axis.plot(br_x,br_y,'c-',linewidth=0.5)

##*************** MEM-USAGE ******************************

        if system_data[item_num] == "mu":
            item_num +=1;
            mem_usage = system_data[item_num];
            mem_usage = string._int(mem_usage)/1000;
            item_num +=1;
            if system_data[item_num] == "(+)":
                mem_usage_wml = 1;
            elif system_data[item_num] == "(.)":
                mem_usage_wml = 0;
            item_num +=1;
            del mu_x[0]; del mu_y[0];
            mu_x.append(sample_no); mu_y.append(mem_usage);
            if (mem_usage_wml == 1):
                mu_axis.plot(sample_no , mem_usage,'ro',markersize=5)
            else:
                mu_axis.plot(sample_no , mem_usage,'bo',markersize=5)
            mu_axis.plot(mu_x,mu_y,'c-',linewidth=0.5)


##*************** CURRENT-FPS ******************************


        if system_data[item_num] == "cf":
            item_num +=1;
            current_fps = system_data[item_num]
            item_num +=1;
            del cf_x[0]; del cf_y[0];
            cf_x.append(sample_no); cf_y.append(current_fps);
            cf_axis.plot(sample_no ,current_fps,'co',markersize=5)
            cf_axis.plot(cf_x,cf_y,'m-',linewidth=0.5)

##*************** AVERSGE-FPS ******************************

        if system_data[item_num] == "af":
            item_num +=1;
            average_fps = system_data[item_num]
            item_num +=1;
            del af_x[0]; del af_y[0];
            af_x.append(sample_no); af_y.append(average_fps);
            af_axis.plot(sample_no , average_fps,'co',markersize=5)
            af_axis.plot(af_x,af_y,'m-',linewidth=0.5)

##*************** RENDERED ******************************

        if system_data[item_num] == "re":
            item_num +=1;
            rendered = system_data[item_num]
            item_num +=1;
            del re_x[0]; del re_y[0];
            re_x.append(sample_no); re_y.append(rendered);
            re_axis.plot(sample_no , rendered,'co',markersize=5)
            re_axis.plot(re_x,re_y,'m-',linewidth=0.5)
            
##*************** DROPPED ******************************
    
        if system_data[item_num] == "dr":
            item_num +=1;
            dropped = system_data[item_num]
            item_num +=1;
            del dr_x[0]; del dr_y[0];
            dr_x.append(sample_no); dr_y.append(dropped);
            dr_axis.plot(sample_no , dropped,'co',markersize=5)
            dr_axis.plot(dr_x,dr_y,'m-',linewidth=0.5)

    hold(1);
    draw();
    sample_no +=1;
    if sample_no > xmax:
        xmin = sample_no;
        xmax = sample_no + sample_limit - 1;
        cc_axis.set_xlim(xmin, xmax)
        in_axis.set_xlim(xmin, xmax)
        cm_axis.set_xlim(xmin, xmax)
##        br_axis.set_xlim(xmin, xmax)
        mu_axis.set_xlim(xmin, xmax)
        cf_axis.set_xlim(xmin, xmax)
        af_axis.set_xlim(xmin, xmax)
        re_axis.set_xlim(xmin, xmax)
        dr_axis.set_xlim(xmin, xmax)

server_socket.close()

